package ink.wgink.gateway;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.cloud.gateway.route.RouteLocator;
import org.springframework.cloud.gateway.route.builder.RouteLocatorBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.web.reactive.config.EnableWebFlux;
import org.yaml.snakeyaml.util.UriEncoder;

@EnableConfigurationProperties
@SpringBootApplication(scanBasePackages = {"ink.wgink"})
public class WgGatewayApplication {

    public static void main(String[] args) {
        SpringApplication.run(WgGatewayApplication.class, args);
    }

    @Bean
    public RouteLocator routes(RouteLocatorBuilder builder) {
        RouteLocator routeLocator = builder.routes()
                .route(r -> r
                        .path("/study/**")
                        .filters(f -> f.rewritePath("/study/", "/twoduty/").addRequestHeader("name", UriEncoder.encode("zhangsan")).addRequestParameter("test", "gogo"))
                        .uri("http://192.168.0.120:8080"))
                .build();
        routeLocator.getRoutes().toStream().forEach(System.out::println);
        return routeLocator;
    }


}