package ink.wgink.gateway.config;

import org.springframework.context.annotation.Configuration;
import org.springframework.web.server.ServerWebExchange;
import org.springframework.web.server.WebFilter;
import org.springframework.web.server.WebFilterChain;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: WebFluxConfig
 * @Description:
 * @Author: wanggeng
 * @Date: 2021/4/14 2:42 下午
 * @Version: 1.0
 */
@Configuration
public class WebFluxFilterConfig implements WebFilter {

    @Override
    public Mono<Void> filter(ServerWebExchange serverWebExchange, WebFilterChain webFilterChain) {
        serverWebExchange.getRequest().getHeaders().forEach((k, list) -> {
            System.out.println(k);
            list.forEach(System.out::println);
        });

        return webFilterChain.filter(serverWebExchange);
    }

    public static void main(String[] args) {
        Flux.just("你好1", "你好2").subscribe(c -> {
            System.out.println(c);
        });

        Mono.just("1").subscribe(System.out::println);
    }
}
